searchNodes=[{"type":"extras","title":"GRiSP 2 Support","doc":"This might be the base Nerves System configuration for the GRiSP 2 . This is a work in progress. It may change in backwards incompatible ways and the documentation might be lacking. To do: [x] Bring up Ethernet [x] Bring up WiFi [x] Verify RGB LEDs [ ] Verify DIP switches [ ] Enable 1-Wire and test [ ] Verify SPI [x] Verify MicroSD card works [ ] Verify ATECC608B [ ] Verify HW watchdog [x] Add ramoops support [ ] Review GRiSP2 specs to see what else there is to verify [x] Check that TARGET_GCC_FLAGS are right [x] Update Linux kernel to 5.10 [x] Update Nerves Toolchain 1.5.0 version [x] Implement A/B firmware updates work [x] Create example app that uses GRiSP2. See Circuits Quickstart and Nerves Livebook [x] Review Linux kernel options and compare with other systems [ ] Clean up debug and low hanging items to improve boot time [ ] Clean up changes to GRiSP repositories and send PRs [x] Use GRiSP serial number in hostname Feature Description CPU NXP iMX6ULL, ARM Cortex-A7 @ 696 MHz Memory 512 MB DRAM Storage 4 GB eMMC and optional MicroSD Linux kernel 5.15 w/ Phytec patches IEx terminal ttymxc0 GPIO, I2C, SPI Yes - Elixir Circuits LEDs Yes - named red:indicator-1 , etc. in sys/class/leds ADC - PWM - UART ttymxc0-ttymxc5 Camera None Ethernet Yes WiFi Yes - 2.4GHz station mode (no Soft-AP) (R8188EU) HW Watchdog i.MX6 watchdog enabled on boot","ref":"readme.html"},{"type":"extras","title":"GRiSP 2 Support - Using","doc":"The most common way of using this Nerves System is create a project with mix nerves.new and to export MIX_TARGET=grisp2 . See the Getting started guide for more information. If you need custom modifications to this system for your device, clone this repository and update as described in Making custom systems","ref":"readme.html#using"},{"type":"extras","title":"GRiSP 2 Support - Boot notes","doc":"This system isn't ready for general use. If you know how to build a Nerves system, then it will probably be a little frustrating, but you'll get something to boot. Build the system Create a test Nerves project or try circuits_quickstart to use it. Build the project with mix firmware . Then run mix firmware.image to get an image file. gzip the image file and copy to a FAT-formatted MicroSD card. Connect the GRiSP2's USB port to your computer and open up a terminal session (115200 8N1). Boot the GRiSP2 and press a key to break into the bootloader. Run: uncompress / mnt / mmc / myfirmware . img . gz / dev / mmc1 reset Now you should be able to use mix upload or ./upload.sh for subsequent updates. The firmware is set to auto-validate.","ref":"readme.html#boot-notes"},{"type":"extras","title":"GRiSP 2 Support - Console access","doc":"GRISP2 will create two virtual UART ports when plugged in. The second of these will contain a system console where you can interact with BareBox and the Elixir Shell. On Linux, this looks like: / dev / ttyUSB0 / dev / ttyUSB1 You can connect via picocom with: picocom / dev / ttyUSB1 115200 NOTE: This differs from the Official GRISP2 guide in that we don't need the --echo flag.","ref":"readme.html#console-access"},{"type":"extras","title":"GRiSP 2 Support - PMOD usage","doc":"The GRiSP 2 has five PMOD interfaces. GPIO pins should all be accessible. Pins for other functions are configured for those functions: UART PMOD - access the UART pins via ttymcx3 I2C PMOD - access I2C via i2c-1 SPI1 PMOD - access SPI via spidev0.0 SPI2 PMOD - access SPI via spidev0.1","ref":"readme.html#pmod-usage"},{"type":"extras","title":"GRiSP 2 Support - Provisioning devices","doc":"TODO: The GRiSP 2 includes an ATECC608A so provisioning the board for use with NervesHub can be done without setting U-Boot environment variables.","ref":"readme.html#provisioning-devices"},{"type":"extras","title":"GRiSP 2 Support - Linux versions","doc":"TBD We're currently using PHYTEC's Linux kernel fork from git.phytec.de/linux-mainline .","ref":"readme.html#linux-versions"},{"type":"extras","title":"Changelog","doc":"This project does NOT follow semantic versioning. The version increases as follows: Major version updates are breaking updates to the build infrastructure. These should be very rare. Minor version updates are made for every major Buildroot release. This may also include Erlang/OTP and Linux kernel updates. These are made four times a year shortly after the Buildroot releases. Patch version updates are made for Buildroot minor releases, Erlang/OTP releases, and Linux kernel updates. They're also made to fix bugs and add features to the build infrastructure.","ref":"changelog.html"},{"type":"extras","title":"Changelog - v0.7.1","doc":"This release enables UART, I2C, and SPI support on the PMOD interfaces. See README.md for device names. Updated dependencies Linux 5.15.102 + Phytec patches","ref":"changelog.html#v0-7-1"},{"type":"extras","title":"Changelog - v0.7.0","doc":"This is a major update that brings in Erlang/OTP 26 and Buildroot 2023.02.2. New features CA certificates are included for OTP 26. Updated dependencies nerves_system_br v1.23.1 Buildroot 2023.02.2 Erlang/OTP 26.0.2","ref":"changelog.html#v0-7-0"},{"type":"extras","title":"Changelog - v0.6.2","doc":"This is a bug and security fix update. It should be a low risk upgrade. Updated dependencies nerves_system_br v1.22.5 Buildroot 2022.11.3","ref":"changelog.html#v0-6-2"},{"type":"extras","title":"Changelog - v0.6.1","doc":"This is a bug fix and Erlang version bump from 25.2 to 25.2.3. It should be a low risk upgrade from v0.6.0. Fixes Set Erlang crash dump timer to 5 seconds, so if an Erlang crash dump does happen, it will run for at most 5 seconds. See erlinit.conf. Updated dependencies nerves_system_br v1.22.3 Buildroot 2022.11.1","ref":"changelog.html#v0-6-1"},{"type":"extras","title":"Changelog - v0.6.0","doc":"This is a Buildroot version update that appears to mostly contain bug and security fixes. Updated dependencies nerves_system_br v1.22.1 Buildroot 2022.11 GCC 12.2","ref":"changelog.html#v0-6-0"},{"type":"extras","title":"Changelog - v0.5.2","doc":"Changes Two Buildroot patch updates and an Erlang minor version update Nerves Heart v2.0 is now included. Nerves Heart connects the Erlang runtime to a hardware watchdog. v2.0 has numerous updates to improve information that you can get and also has more safeguards to avoid conditions that could cause a device to hang forever. Updated dependencies nerves_system_br v1.21.6 Erlang/OTP 25.2 Buildroot 2022.08.3 nerves_heart v2.0.2","ref":"changelog.html#v0-5-2"},{"type":"extras","title":"Changelog - v0.5.1","doc":"Changes Reduce first-time Linux kernel download by using tarball source Updated dependencies nerves_system_br v1.21.2 Erlang/OTP 25.1.2","ref":"changelog.html#v0-5-1"},{"type":"extras","title":"Changelog - v0.5.0","doc":"Updated dependencies nerves_system_br v1.21.1 and also see nerves_system_br v1.21.0 Buildroot 2022.08.1 Erlang/OTP 25.1.1","ref":"changelog.html#v0-5-0"},{"type":"extras","title":"Changelog - v0.4.2","doc":"Updated dependencies nerves_system_br v1.20.6 Erlang/OTP 25.0.4 Buildroot 2022.05.2 Also see Buildroot 2022.05.1 changes","ref":"changelog.html#v0-4-2"},{"type":"extras","title":"Changelog - v0.4.1","doc":"Updated dependencies nerves_system_br v1.20.4 Erlang/OTP 25.0.3","ref":"changelog.html#v0-4-1"},{"type":"extras","title":"Changelog - v0.4.0","doc":"This release updates to Buildroot 2022.05 and uses GCC 11.3 (from GCC 10.3). Updated dependencies nerves_system_br v1.20.3 Buildroot 2022.05 Erlang/OTP 25.0.2","ref":"changelog.html#v0-4-0"},{"type":"extras","title":"Changelog - v0.3.0","doc":"This release updates to Buildroot 2022.02.1 and OTP 25.0. While this should be an easy update for most projects, many programs have been updated. Please review the changes in the updated dependencies for details. Updated dependencies nerves_system_br v1.19.0 Buildroot 2022.02.1 . Also see Buildroot 2022.02 Erlang/OTP 25.0","ref":"changelog.html#v0-3-0"},{"type":"extras","title":"Changelog - v0.2.3","doc":"This release bumps Erlang to 24.3.2 and should be a low risk upgrade from the previous release. Changes Pull in upstream Linux SquashFS patch to improve file system performance Switch back to using kernel modules for WiFi drivers to avoid needing to build regulatory information into the kernel. Updated dependencies nerves_system_br v1.18.6","ref":"changelog.html#v0-2-3"},{"type":"extras","title":"Changelog - v0.2.2","doc":"Changes Enable the ramoops driver to capture log messages right before an unexpected reboot. Turn off unused kernel options and adjust for faster boot times and smaller images.","ref":"changelog.html#v0-2-2"},{"type":"extras","title":"Changelog - v0.2.1","doc":"This release has various Linux device tree and option updates to bootup warnings and allow more hardware to be accessed in Elixir. Changes Use the serial number printed on the GRiSP board Updated dependencies nerves_system_br v1.18.5","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"Changelog - v0.2.0","doc":"This is a very early port to the GRiSP2. It runs off eMMC, supports A/B firmware updates like other Nerves devices, and basics like WiFi look like they work. Dependencies nerves_system_br v1.18.4 Erlang 24.2.1 Linux 5.10.76 with PHYTEC kernel patches","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"Changelog - v0.1.0","doc":"Dependencies nerves_system_br v1.7.1 Erlang 21.2.7 Linux 4.14.93 with PHYTEC kernel patches","ref":"changelog.html#v0-1-0"}]